GNU bug report logs - #25380
25.1; save-window-excursion problem in batch mode

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Philipp Stephani <p.stephani2@HIDDEN>; dated Fri, 6 Jan 2017 23:06:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 10 Jan 2017 18:07:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 10 13:07:05 2017
Received: from localhost ([127.0.0.1]:49110 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cR0p7-0001mS-Oj
	for submit <at> debbugs.gnu.org; Tue, 10 Jan 2017 13:07:05 -0500
Received: from mout.gmx.net ([212.227.17.22]:53100)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1cR0p6-0001lw-Eq
 for 25380 <at> debbugs.gnu.org; Tue, 10 Jan 2017 13:07:05 -0500
Received: from [192.168.1.101] ([212.95.7.52]) by mail.gmx.com (mrgmx101
 [212.227.17.168]) with ESMTPSA (Nemesis) id 0MbsV8-1c8w0J3q6Q-00JL8K; Tue, 10
 Jan 2017 19:06:54 +0100
Message-ID: <587522B4.8080305@HIDDEN>
Date: Tue, 10 Jan 2017 19:06:44 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN>
 <7qwpe5xusr.fsf@HIDDEN>	<58735A58.80801@HIDDEN>
 <83pojwi7qc.fsf@HIDDEN>	<5873B811.4000404@HIDDEN> <83inpodvyw.fsf@HIDDEN>
 <837f62et6o.fsf@HIDDEN>
In-Reply-To: <837f62et6o.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K0:L4cx3Frk1njN96DDeSvw83Y7i6KsLHeKtOycWelPGW5H4PrkGVP
 IyLEDBRgTqLSZcWY9UVQmRkKDAk0kunpIn8IAmKIpcbHAQPjbuufZICumhlZWaxuMe76Tv/
 ZYDA2soqXeriXpyuWv0BCrbyuvFfjmlhdXXkx38jkIRE7ivLRhggjM++yVpyQTz6wDITDui
 4zu2Y03FBjMH9zWnN0UUw==
X-UI-Out-Filterresults: notjunk:1;V01:K0:/eB+6q0/3j8=:WaQA8zH4h+eYmMHQy4M7Y8
 nciGMXZSnvQGcyo+76+X2NuFOjoqQSTZaAY3FZcphyiXK5nAZJlsM8EGfs2izPHP2OWDj44Ti
 hqyyviEQ0BeJsMMOBlX8eyVJTE1YLv2G+mMC4TTJ3HpJ8hYGO17Ih2bTfT0LT6rWSYBiytK2G
 1QwvhIjA/pgeq+2UK7Fgl48Xl3/mHTsj3cpCdZ9HXPUoxuHpBAE4eTv38H+WGPD54GYDmnbhF
 MGxW6jxqCepXNKGrv/V0Bw2FX6uU34z7MItxZKuMeAi8BEOXsNfbGwKk25ObY7sDRqcCy/KlT
 F+tEHkiuhI77SVe65+0wKrI/53KXH3KmOJP9s3NI3xbO+U2wrtviCMX6xl1uKEiSujDsJP6hE
 G+85W/xB0QW2wcistpnrAG0tIuchGI9X3H+KGOm16s03oU95H87B+oFKZQiYR/Pk06LofQXBr
 X4jetm0K504US+fO3/11DxcP6gi8WuCVebuPvsFBxX3xnH2UT5uDkF8pcfU4y+sF+6ozWd0tC
 Ex/TUaQCh8aZqulXXR7TlhNTNRhF92W5Ds7ftTRblpud2XmjYl8osYQ7DteAw9FMJvjELm0Ig
 mX/3i+/Pky6HcziMeYl9llxjIZHyYpC01/tppjmsV5hUCVl+A899SuLVgg7RgjuoYoKAx0g9j
 rguiRJmq0EwLYWA8h2BQqy7LABDN/rxuTOGRj5w4x/E5Uz9uFR0nkAws8uRKQmGglkxAX0/Fm
 gFZ80BTLijfVOuYjPsHHYuVp18z+U0k48XYxOhI14m7ks1tJlBETUSHOLS5BW7Iuw24CADYq2
 w9nrOGTqJPDFU+KvzUV9dx/va6PmRKvjHEwfyUNXKTXuGjzS2+/3S98bhz6JLeSNZQihMruDT
 cqvri0Y23hcIbUCLqke5rx4mQQ+9s31XDTWeW5hc2iIRkBo5bMq6uW23X4TPN2PjknRnSuZg/
 DgAt7Qf38o/pBYrjP+a6c3M4TZyZ6IHp3LawKtoB+DLxSzdOWflRd9Jv7HIqYZUh0Squ+20FA
 POj9zXjD2PaFpc5xKs2p7yZZ8X5BWbAQCU4Uq4F4qUkF
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: > So perhaps one possible solution would be to call
 resize_frame_windows
 > somehow during temacs run. Which code does create that frame?
 make_terminal_frame? martin [...] 
 Content analysis details:   (2.2 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 FREEMAIL_FROM Sender email is commonly abused enduser mail provider
 (rudalics[at]gmx.at)
 3.6 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [212.95.7.52 listed in dnsbl.sorbs.net]
 0.5 RCVD_IN_SORBS_SPAM     RBL: SORBS: sender is a spam source
 [212.227.17.22 listed in dnsbl.sorbs.net]
 -1.2 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [212.227.17.22 listed in wl.mailspike.net]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at http://www.dnswl.org/, low
 trust [212.227.17.22 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 25380
Cc: p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > So perhaps one possible solution would be to call resize_frame_windows
    > somehow during temacs run. Which code does create that frame? make_terminal_frame?
    martin [...] 
 
 Content analysis details:   (2.2 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.5 RCVD_IN_SORBS_SPAM     RBL: SORBS: sender is a spam source
                             [212.227.17.22 listed in dnsbl.sorbs.net]
  3.6 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
                             [212.95.7.52 listed in dnsbl.sorbs.net]
 -1.2 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [212.227.17.22 listed in wl.mailspike.net]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at http://www.dnswl.org/, low
                             trust
                             [212.227.17.22 listed in list.dnswl.org]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail provider
                             (rudalics[at]gmx.at)
 -0.0 SPF_PASS               SPF: sender matches SPF record

 > So perhaps one possible solution would be to call resize_frame_windows
 > somehow during temacs run.

Which code does create that frame?  make_terminal_frame?

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 10 Jan 2017 17:11:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 10 12:11:37 2017
Received: from localhost ([127.0.0.1]:49083 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQzxR-000747-DT
	for submit <at> debbugs.gnu.org; Tue, 10 Jan 2017 12:11:37 -0500
Received: from eggs.gnu.org ([208.118.235.92]:43636)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1cQzxQ-00073t-By
 for 25380 <at> debbugs.gnu.org; Tue, 10 Jan 2017 12:11:36 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1cQzxI-000153-6H
 for 25380 <at> debbugs.gnu.org; Tue, 10 Jan 2017 12:11:31 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.4 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:33655)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1cQzxI-00014y-38; Tue, 10 Jan 2017 12:11:28 -0500
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2242
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1cQzxH-0003ca-8R; Tue, 10 Jan 2017 12:11:27 -0500
Date: Tue, 10 Jan 2017 19:11:27 +0200
Message-Id: <837f62et6o.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: rudalics@HIDDEN
In-reply-to: <83inpodvyw.fsf@HIDDEN> (message from Eli Zaretskii on Mon, 09
 Jan 2017 18:44:23 +0200)
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
 <58735A58.80801@HIDDEN> <83pojwi7qc.fsf@HIDDEN>
 <5873B811.4000404@HIDDEN> <83inpodvyw.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -8.2 (--------)
X-Debbugs-Envelope-To: 25380
Cc: p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -8.2 (--------)

> Date: Mon, 09 Jan 2017 18:44:23 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
> 
> >  > I just ran Emacs under a debugger with a breakpoint in
> >  > Fcurrent_window_configuration, then put a watchpoint on every top_line
> >  > member of every window that got saved there, and waited for it to
> >  > break.
> > 
> > That's obvious.  But how do I find out where that menubar line gets set?
> 
> I will see what I can do about that.

Further debugging reveals that I was mistaken: the frame's
FRAME_MENU_BAR_LINES value is already 1 when Emacs starts.  The
problem is that the window's top is not in sync with that value; I
guess resize_frame_windows was never called for the windows of the
frame, not even in temacs.

So perhaps one possible solution would be to call resize_frame_windows
somehow during temacs run.

> Could this be related to the bug#18136, bug#18196 woes?

Only tangentially, I think.  IOW, the same code is involved here, but
the menu-bar lines value is correct in this case.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 10 Jan 2017 08:22:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 10 03:22:31 2017
Received: from localhost ([127.0.0.1]:48373 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQrhP-0000Is-Nz
	for submit <at> debbugs.gnu.org; Tue, 10 Jan 2017 03:22:31 -0500
Received: from mout.gmx.net ([212.227.17.20]:49332)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1cQrhN-0000Id-D2
 for 25380 <at> debbugs.gnu.org; Tue, 10 Jan 2017 03:22:29 -0500
Received: from [192.168.1.100] ([212.95.7.56]) by mail.gmx.com (mrgmx101
 [212.227.17.168]) with ESMTPSA (Nemesis) id 0LmfKJ-1d0kc2376B-00aB2X; Tue, 10
 Jan 2017 09:22:21 +0100
Message-ID: <587499B5.90101@HIDDEN>
Date: Tue, 10 Jan 2017 09:22:13 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
 <58735A58.80801@HIDDEN> <83pojwi7qc.fsf@HIDDEN> <5873B811.4000404@HIDDEN>
 <83inpodvyw.fsf@HIDDEN>
In-Reply-To: <83inpodvyw.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K0:J/R/08aTuStTNDxlOC7rlFfVp6oISmNkd+O4mwFOuwnDXMipzQU
 +VdII52mLvt18buDenepIaNQ8MaygLJerOApYbiWRALZyMNsn0gA9agBBlyrIcML2aYxAP0
 j8i665Pxys/gz6Sn56fc4mOPRankW6ObagXZNix/QdRVqG7MvsiKhwRK28YiJk1pA+Kw+6m
 o75szvpLkYmHHnvYif1ng==
X-UI-Out-Filterresults: notjunk:1;V01:K0:0umC9pJWwl8=:4TM0VnnZ+UiStf9OPPp32I
 6y9+ltELPVbH5eGY/jDq/XQegGxPsHkDbMlmQpaqcZcGhKKv9D0IxLUJtqtOqLIctoGrW715F
 U1NiEEDaOt3Td9cy9ZKWs5yIAb6JeS+ahpUUzgEWkcrIXLX3Xv2LDBQnlWkJm//pDrh6IUao6
 vPG2Um6SHehqbGXkJwfo9GMHhFJvy+Psw6VGYYnfi5OVP/phM0+fDrl4KPU/4KjVIP9vk/kv8
 qx0pPpdc0MHD4k8H+DCuxWeUZZ2ujW4mCgYPILO63rarDTbyTYWibWOE4I+u3e/Zyu3DDx1ph
 3fDQkCnv67e9U9LV8uH+Hqk+y2ykuxOrHx50j7E15rVLKR4BJor5hHWYi2sCJCihgjbtG9+3A
 FoBx8QKi9uzRRWv2hdgTVEcR0oaEAIYbNyg0En2Wa6x1iRmalbSDhuAYYY9Rn+TdKO2SrOksL
 uDnq20fk8IO7jVezG62DSdN0EfcC9igCZR5+qrajntckiFR4F/uQ3bZnSAnpVVRQMdm0JShJy
 W1l6Oxv6IkaBdVko0kNcea9G26slz9iajnx6JonKdBhC4TlalcBzX3KwBY9eftJMnGV64bPlH
 wKZs+nzttVs8ZoWMoyHxpxDs9e+9QF52+1LiMaXDYLtwFgxHuyc8Q+3RiG/BR2rvWOp+z0Hob
 DCvYAkrxJMi3WiSd52UvjHhAd5gAgpnVIdZbtXTLw+nc3tJBuL/+2qfdsXmROZ6+pJRH973II
 7Rly39qZVbhSlch+uZmvy5k8oT5Z1aywe8F/flRRXzNnHMmWCRhO5HiHQ1aQ/wEgH2aVw8nEK
 Xll7z18DqtkiKKVexckv7ibMkjP2A==
X-Spam-Score: 1.7 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  > Yes, but in a batch session 1 pixel = 1 character (it's
 not a GUI > session), right? Right. >> That's obvious. But how do I find
 out where that menubar line gets set? > > I will see what I can do about that.
 [...] Content analysis details:   (1.7 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 FREEMAIL_FROM Sender email is commonly abused enduser mail provider
 (rudalics[at]gmx.at)
 -1.2 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [212.227.17.20 listed in wl.mailspike.net]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at http://www.dnswl.org/, low
 trust [212.227.17.20 listed in list.dnswl.org]
 3.6 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [212.95.7.56 listed in dnsbl.sorbs.net]
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 25380
Cc: rgm@HIDDEN, p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.7 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > Yes, but in a batch session 1 pixel = 1 character (it's
    not a GUI > session), right? Right. >> That's obvious. But how do I find
   out where that menubar line gets set? > > I will see what I can do about that.
    [...] 
 
 Content analysis details:   (1.7 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  3.6 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
                             [212.95.7.56 listed in dnsbl.sorbs.net]
 -1.2 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [212.227.17.20 listed in wl.mailspike.net]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at http://www.dnswl.org/, low
                             trust
                             [212.227.17.20 listed in list.dnswl.org]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail provider
                             (rudalics[at]gmx.at)
 -0.0 SPF_PASS               SPF: sender matches SPF record

 > Yes, but in a batch session 1 pixel = 1 character (it's not a GUI
 > session), right?

Right.

 >> That's obvious.  But how do I find out where that menubar line gets set?
 >
 > I will see what I can do about that.

Could this be related to the bug#18136, bug#18196 woes?

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 9 Jan 2017 16:44:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 09 11:44:39 2017
Received: from localhost ([127.0.0.1]:47986 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQd3n-0008SZ-J5
	for submit <at> debbugs.gnu.org; Mon, 09 Jan 2017 11:44:39 -0500
Received: from eggs.gnu.org ([208.118.235.92]:58699)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1cQd3l-0008SM-J4
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 11:44:38 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1cQd3d-0005RQ-4A
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 11:44:32 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.4 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:45639)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1cQd3d-0005RD-0m; Mon, 09 Jan 2017 11:44:29 -0500
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:1379
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1cQd3b-0001eD-UO; Mon, 09 Jan 2017 11:44:28 -0500
Date: Mon, 09 Jan 2017 18:44:23 +0200
Message-Id: <83inpodvyw.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-reply-to: <5873B811.4000404@HIDDEN> (message from martin rudalics on Mon,
 09 Jan 2017 17:19:29 +0100)
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
 <58735A58.80801@HIDDEN> <83pojwi7qc.fsf@HIDDEN> <5873B811.4000404@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -8.2 (--------)
X-Debbugs-Envelope-To: 25380
Cc: rgm@HIDDEN, p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -8.2 (--------)

> Date: Mon, 09 Jan 2017 17:19:29 +0100
> From: martin rudalics <rudalics@HIDDEN>
> CC: rgm@HIDDEN, p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
> 
>  >> IIUC the pixel comes from a menubar line which gets spuriously added.
>  >
>  > I believe you are right, see the backtrace below from the place which
>  > changes the value from 0 to 1 (it's not pixel units, btw, it's
>  > character units, AFAIU).
> 
> At the time the comparison fails in ‘compare-window-configurations’ it's
> at !EQ (sw1->pixel_top, sw2->pixel_top) so it's off by one pixel.  It
> probably would fail later at !EQ (sw1->top_line, sw2->top_line) as well.

Yes, but in a batch session 1 pixel = 1 character (it's not a GUI
session), right?

>  > More accurately, the initial current-window-configuration call happens
>  > so early that the basic geometry of the "windows" is not yet set, and
>  > in particular the menu bar is not yet computed and accounted for.
>  > This is indeed where Emacs 25 behaves differently from previous
>  > versions, and for a very good reason.
> 
> Does the basic geometry of the "windows" ever get set?  Would I have to
> create a frame manually for that?

Yes.  No.

>  >> If someone told me how to debug this, I might be able to tell more.
>  >
>  > I just ran Emacs under a debugger with a breakpoint in
>  > Fcurrent_window_configuration, then put a watchpoint on every top_line
>  > member of every window that got saved there, and waited for it to
>  > break.
> 
> That's obvious.  But how do I find out where that menubar line gets set?

I will see what I can do about that.

>  >> I have no idea how the frame seen by ‘current-window-configuration’
>  >> gets created in batch mode.
>  >
>  > It comes from temacs, AFAIR.
> 
> Hmm... the normal "F1" frame made by ‘make_initial_frame’.  Still: Who
> adds the menubar line?  AFAIK neither NS nor GTK should.

It's a batch session, so the text-mode part is probably the one.

>  >    emacs -batch -eval "(progn (save-window-excursion (current-window-configuration)) (print (equal (save-window-excursion (current-window-configuration)) (current-window-configuration))))" => t
> 
> emacs -batch -eval "(progn (menu-bar-mode -1) (print (equal (save-window-excursion (current-window-configuration)) (current-window-configuration))))"
> 
> works here too.

Of course.  Like I said: trickery.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 9 Jan 2017 16:19:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 09 11:19:49 2017
Received: from localhost ([127.0.0.1]:47976 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQcfj-0007qc-RQ
	for submit <at> debbugs.gnu.org; Mon, 09 Jan 2017 11:19:49 -0500
Received: from mout.gmx.net ([212.227.17.21]:49992)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1cQcfi-0007qP-UD
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 11:19:47 -0500
Received: from [192.168.1.100] ([212.95.7.106]) by mail.gmx.com (mrgmx103
 [212.227.17.168]) with ESMTPSA (Nemesis) id 0LeeNW-1cpBFm21S2-00qQeG; Mon, 09
 Jan 2017 17:19:36 +0100
Message-ID: <5873B811.4000404@HIDDEN>
Date: Mon, 09 Jan 2017 17:19:29 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
 <58735A58.80801@HIDDEN> <83pojwi7qc.fsf@HIDDEN>
In-Reply-To: <83pojwi7qc.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K0:jyV1zpdD7NucY5qeUcem3PNu4HEe8SXt2W4BynSIKiMG3F5UAar
 ONgD1ytSzujIgf/5FLT2mncoIyG6kprVqaZ7fSPpOHMyZEw94KUFJVa6ewJpHDUeqj2/Vcv
 o3ki2UxbOCXAOtQYDOnkQCq+Ng4h8Z/YJLMpfWpxSOHX4APcs/AAKRBnFtc0Pii2ccZKjrb
 PmL0kAe0mYw0qzMihX14Q==
X-UI-Out-Filterresults: notjunk:1;V01:K0:TfJ/EnUHuH8=:U6UWmigKfDg8mwPwHUv4Xn
 kgapX202Gg4neuqWfiS5ZR1aQ1Jt+82NGqrE261PZcbWZJ4cQjKiaJ0BvVkUtUb3lAoz91TGk
 IIarXgAwwgU18axUgDa/0M3jCD6dVAEdzUorm4bWVPDF9efz8Nq5XyZTMkR1TmWr1zWtgj9JS
 w1KRSh0b2sDZNh/vTY1AkrEDPZc5ppuazLyy085UUdElQpj1ISTXP5dJA8EFCEEWbvL9wWGQC
 sVRVtlLQmRxuiZobOfOEZoqSQ1/azEaII7ZXA24NqjyTAR64I8cwurwRn+DhAtfwbDmajloxR
 RCZPPSF64p7L7awsxKyaoXJZDfUq4eRkrpu61EFsQhI6kpbX3u+ORvRiCNnbSoaLE2VrjVfSA
 cj2dmhGCAYTbgdLBSOxxyNZkLZlAQVNcLyukMa1p9HhFLGXd6sVUieEZT+bu2UWJ/vV3pFO6e
 1tLU5rOyJ2efCXrcE01mOEtor0YVVhATDQYXvWFU0tKrVEjTAriSGUdHMcvxeqp+rytKVMa9k
 oPTIIBvzTZ49JWAZ0tbeiQC/EeubD9Zuqd9DoIIBK8tISlE9QAS4mWmBnDQsCPgSUeXPMpzeK
 60D/iUoRWuXcmldwA75vfTdrZ3SA4l6Ph/ZYAjMsIwtEM6Y4s1r2Cve6acELj2mBVUQG2znte
 QZeEi6wBez8Dfm1ahLI55cGKobQ0EAfoGuHI0M7eeoQwoxKIIGwOYq3ppUtRHMGoDa8Lfk71W
 UiWQ92KhvQLDAVI+JOveDWnUjM6VUb/0zRdYC1hHGTXvprbbr/4gH/wGX/Xmds8lWPfI5BPMw
 tsjCcDWem6b8LasPgbwIrCAhOqqdVYP2eNvr7njRD8q3kdICyfvaV7XA+qbc20hVRK9ps7OjG
 5Ddb16zqHnw5WHTLb7SndFKNVSiKBa8tdKvuXwX9amJ2oiN6901uwv7fKU1ncvvll47lBbHdq
 kLSIAFUAIwG+dToOej4PWkIP1y4ymYSSzM0T9yF7jLjo3dsYAUy1gyeGBjFIOARLFZIcKtqEc
 xYaRmdsSRZysPpaVqovwH5SI9qr+PcwvQovs0RTB7vV2Y10Rgu3wxPhhNGoRhLf8iw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 25380
Cc: rgm@HIDDEN, p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

 >> IIUC the pixel comes from a menubar line which gets spuriously added.=

 >
 > I believe you are right, see the backtrace below from the place which
 > changes the value from 0 to 1 (it's not pixel units, btw, it's
 > character units, AFAIU).

At the time the comparison fails in =E2=80=98compare-window-configuration=
s=E2=80=99 it's
at !EQ (sw1->pixel_top, sw2->pixel_top) so it's off by one pixel.  It
probably would fail later at !EQ (sw1->top_line, sw2->top_line) as well.

 > More accurately, the initial current-window-configuration call happens=

 > so early that the basic geometry of the "windows" is not yet set, and
 > in particular the menu bar is not yet computed and accounted for.
 > This is indeed where Emacs 25 behaves differently from previous
 > versions, and for a very good reason.

Does the basic geometry of the "windows" ever get set?  Would I have to
create a frame manually for that?

 >> If someone told me how to debug this, I might be able to tell more.
 >
 > I just ran Emacs under a debugger with a breakpoint in
 > Fcurrent_window_configuration, then put a watchpoint on every top_line=

 > member of every window that got saved there, and waited for it to
 > break.

That's obvious.  But how do I find out where that menubar line gets set?

 >> I have no idea how the frame seen by =E2=80=98current-window-configur=
ation=E2=80=99
 >> gets created in batch mode.
 >
 > It comes from temacs, AFAIR.

Hmm... the normal "F1" frame made by =E2=80=98make_initial_frame=E2=80=99=
=2E  Still: Who
adds the menubar line?  AFAIK neither NS nor GTK should.

 > I'm not actually certain we should try fixing this, unless Martin can
 > do that in some easy and safe way.  The code involved in this is quite=

 > fragile, because Emacs creates its first frame without knowing
 > anything about its geometry and the window-system.  That code took a
 > long time to get right on all systems; I'd hate to break it to cater
 > to (IMO) much less important use cases.  I'd rather people wouldn't
 > count on anything related to "frames" and "windows" in the batch
 > session, except that they exist.  (They must exist because some
 > functions will simply not work without a frame or a window.)

So far I can't do anything here - this is code I cannot debug.  At the
time =E2=80=98compare-window-configurations=E2=80=99 gets called it's alr=
eady much too
late :-(

 > IOW, I think unit tests that must compare windows cannot be na=C3=AFve=
ly
 > run in batch mode; you need to use tricks.  For example:
 >
 >    emacs -batch -eval "(progn (save-window-excursion (current-window-c=
onfiguration)) (print (equal (save-window-excursion (current-window-confi=
guration)) (current-window-configuration))))" =3D> t

emacs -batch -eval "(progn (menu-bar-mode -1) (print (equal (save-window-=
excursion (current-window-configuration)) (current-window-configuration))=
))"

works here too.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 9 Jan 2017 15:16:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 09 10:16:56 2017
Received: from localhost ([127.0.0.1]:47950 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQbgu-0006Lv-CH
	for submit <at> debbugs.gnu.org; Mon, 09 Jan 2017 10:16:56 -0500
Received: from eggs.gnu.org ([208.118.235.92]:37205)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1cQbgs-0006Lh-Mk
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 10:16:55 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1cQbgk-0000st-5H
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 10:16:49 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.4 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:44743)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1cQbgk-0000sl-2N; Mon, 09 Jan 2017 10:16:46 -0500
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:1712
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1cQbgj-0005yl-0N; Mon, 09 Jan 2017 10:16:45 -0500
Date: Mon, 09 Jan 2017 17:16:43 +0200
Message-Id: <83pojwi7qc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
In-reply-to: <58735A58.80801@HIDDEN> (message from martin rudalics on Mon, 09
 Jan 2017 10:39:36 +0100)
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
 <58735A58.80801@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -8.2 (--------)
X-Debbugs-Envelope-To: 25380
Cc: rgm@HIDDEN, p.stephani2@HIDDEN, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -8.2 (--------)

> Date: Mon, 09 Jan 2017 10:39:36 +0100
> From: martin rudalics <rudalics@HIDDEN>
> Cc: 25380 <at> debbugs.gnu.org
> 
> > It works in 24.5 and earlier. Something to do with window-edges?
> >
> > emacs -Q -batch --eval '(progn (setq c (current-window-configuration))
> > (print (window-edges))
> > (set-window-configuration c)
> > (print (window-edges)))'
> >
> > 24.5:
> > (0 1 10 9)
> > (0 1 10 9)
> >
> > 25.1:
> > (0 0 10 9)
> > (0 1 10 10)
> 
> IIUC the pixel comes from a menubar line which gets spuriously added.

I believe you are right, see the backtrace below from the place which
changes the value from 0 to 1 (it's not pixel units, btw, it's
character units, AFAIU).

More accurately, the initial current-window-configuration call happens
so early that the basic geometry of the "windows" is not yet set, and
in particular the menu bar is not yet computed and accounted for.
This is indeed where Emacs 25 behaves differently from previous
versions, and for a very good reason.

> If someone told me how to debug this, I might be able to tell more.

I just ran Emacs under a debugger with a breakpoint in
Fcurrent_window_configuration, then put a watchpoint on every top_line
member of every window that got saved there, and waited for it to
break.

> I have no idea how the frame seen by ‘current-window-configuration’
> gets created in batch mode.

It comes from temacs, AFAIR.

Turning back to the original report:

> $ emacs -Q -batch -eval '(print (equal (save-window-excursion 
> (current-window-configuration)) (current-window-configuration)))'
> 
> nil
> 
> This is unexpected, especially in unit tests that want to check window
> comparisons.  In interactive mode, this works (i.e. (equal
> (save-window-excursion (current-window-configuration))
> (current-window-configuration)) is t).

(This works in an interactive session because by the time you evaluate
the form, the frame geometry has been completely computed and set up.)

I'm not actually certain we should try fixing this, unless Martin can
do that in some easy and safe way.  The code involved in this is quite
fragile, because Emacs creates its first frame without knowing
anything about its geometry and the window-system.  That code took a
long time to get right on all systems; I'd hate to break it to cater
to (IMO) much less important use cases.  I'd rather people wouldn't
count on anything related to "frames" and "windows" in the batch
session, except that they exist.  (They must exist because some
functions will simply not work without a frame or a window.)

IOW, I think unit tests that must compare windows cannot be naïvely
run in batch mode; you need to use tricks.  For example:

  emacs -batch -eval "(progn (save-window-excursion (current-window-configuration)) (print (equal (save-window-excursion (current-window-configuration)) (current-window-configuration))))" => t

Here's the backtrace which shows where we change the top pixel from
zero to 1:

Thread 1 hit Hardware watchpoint 4: -location w->pixel_top

Old value = 0
New value = 1
resize_frame_windows (f=0x17752c8 <dumped_data+95208>, size=10,
    horflag=false, pixelwise=true) at window.c:4125
4125            r->total_lines = new_size;
(gdb) bt
#0  resize_frame_windows (f=0x17752c8 <dumped_data+95208>, size=10,
    horflag=false, pixelwise=true) at window.c:4125
#1  0x01014819 in adjust_frame_size (f=0x17752c8 <dumped_data+95208>,
    new_width=-1, new_height=-1, inhibit=1, pretend=false, parameter=52528)
    at frame.c:550
#2  0x010cf523 in Fset_window_configuration (
    configuration=-6917529027611094376) at window.c:6404
#3  0x012278e1 in eval_sub (form=-4611686018401701024) at eval.c:2211
#4  0x01220476 in Fprogn (body=-4611686018401701056) at eval.c:450
#5  0x0122052a in unwind_body (body=-4611686018401701056) at eval.c:463
#6  0x0122c92a in do_one_unbind (this_binding=0x88dc10, unwinding=true)
    at eval.c:3379
#7  0x0122cd0c in unbind_to (count=18, value=-6917529027611093664)
    at eval.c:3499
#8  0x01223b37 in Funwind_protect (args=-4611686018401701584) at eval.c:1198
#9  0x01227368 in eval_sub (form=-4611686018401701600) at eval.c:2164
#10 0x01220476 in Fprogn (body=-4611686018401701648) at eval.c:450
#11 0x01223005 in Flet (args=-4611686018401701680) at eval.c:973
#12 0x01227368 in eval_sub (form=-4611686018401702176) at eval.c:2164
#13 0x012280ff in eval_sub (form=-4611686018401978320) at eval.c:2282
#14 0x012277fd in eval_sub (form=-4611686018401978192) at eval.c:2199
#15 0x012277fd in eval_sub (form=-4611686018401978160) at eval.c:2199
#16 0x01226b8e in Feval (form=-4611686018401978160, lexical=0) at eval.c:2033
#17 0x01229fc9 in funcall_subr (subr=0x167d720 <Seval>, numargs=1,
    args=0x88e738) at eval.c:2812
#18 0x01229a14 in Ffuncall (nargs=2, args=0x88e730) at eval.c:2735
#19 0x0128e4e0 in exec_byte_code (bytestr=-9223372036833358424,
    vector=-6917529027619664456, maxdepth=4611686018427387927,
    args_template=4611686018427388161, nargs=1, args=0x88ec38)
    at bytecode.c:726
#20 0x0122ac8c in funcall_lambda (fun=-6917529027619664520, nargs=1,
    arg_vector=0x88ec30) at eval.c:2935
#21 0x01229a58 in Ffuncall (nargs=2, args=0x88ec28) at eval.c:2737
#22 0x0128e4e0 in exec_byte_code (bytestr=-9223372036833377352,
    vector=-6917529027619683384, maxdepth=4611686018427387925,
    args_template=4611686018427387904, nargs=0, args=0x88f1a8)
    at bytecode.c:726
#23 0x0122ac8c in funcall_lambda (fun=-6917529027619683448, nargs=0,
    arg_vector=0x88f1a8) at eval.c:2935
#24 0x01229a58 in Ffuncall (nargs=1, args=0x88f1a0) at eval.c:2737
#25 0x0128e4e0 in exec_byte_code (bytestr=-9223372036833380592,
    vector=-6917529027619686624, maxdepth=4611686018427387916,
    args_template=4611686018427387904, nargs=0, args=0x88f650)
    at bytecode.c:726
#26 0x0122ac8c in funcall_lambda (fun=-6917529027619686688, nargs=0,
    arg_vector=0x88f650) at eval.c:2935
#27 0x0122a755 in apply_lambda (fun=-6917529027619686688, args=0, count=4)
    at eval.c:2872
#28 0x01227e87 in eval_sub (form=-4611686018401371376) at eval.c:2256
#29 0x01226b8e in Feval (form=-4611686018401371376, lexical=0) at eval.c:2033
#30 0x01156473 in top_level_2 () at keyboard.c:1124
#31 0x0122464a in internal_condition_case (bfun=0x115643d <top_level_2>,
    handlers=21728, hfun=0x1155bf4 <cmd_error>) at eval.c:1336
#32 0x011564d9 in top_level_1 (ignore=0) at keyboard.c:1132
#33 0x01223786 in internal_catch (tag=58016, func=0x1156479 <top_level_1>,
    arg=0) at eval.c:1101
#34 0x01156355 in command_loop () at keyboard.c:1093
#35 0x01155620 in recursive_edit_1 () at keyboard.c:700
#36 0x011558be in Frecursive_edit () at keyboard.c:771
#37 0x01153068 in main (argc=4, argv=0xc21478) at emacs.c:1686

Lisp Backtrace:
"set-window-configuration" (0x88da40)
"unwind-protect" (0x88dd70)
"let" (0x88e000)
"save-window-excursion" (0x88e170)
"equal" (0x88e2e0)
"print" (0x88e450)
"eval" (0x88e738)
"command-line-1" (0x88ec30)
"command-line" (0x88f1a8)
"normal-top-level" (0x88f650)
(gdb) p FRAME_MENU_BAR_HEIGHT(f)
$8 = 1
(gdb) p FRAME_TOOL_BAR_HEIGHT(f)
$9 = 0
(gdb) p FRAME_TOP_MARGIN_HEIGHT(f)
$10 = 1
(gdb)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 9 Jan 2017 09:39:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 09 04:39:48 2017
Received: from localhost ([127.0.0.1]:47387 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQWQd-0002ET-W6
	for submit <at> debbugs.gnu.org; Mon, 09 Jan 2017 04:39:48 -0500
Received: from mout.gmx.net ([212.227.17.21]:64649)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1cQWQc-0002EG-FA
 for 25380 <at> debbugs.gnu.org; Mon, 09 Jan 2017 04:39:47 -0500
Received: from [192.168.1.100] ([212.95.7.106]) by mail.gmx.com (mrgmx101
 [212.227.17.168]) with ESMTPSA (Nemesis) id 0MVZuV-1by8qW1UCd-00Z2Vg; Mon, 09
 Jan 2017 10:39:35 +0100
Message-ID: <58735A58.80801@HIDDEN>
Date: Mon, 09 Jan 2017 10:39:36 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Glenn Morris <rgm@HIDDEN>, Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
In-Reply-To: <7qwpe5xusr.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K0:y4OR9uuYsPr4KS1dajQWBbdN8pYDppHET7SIO06yg7P6mxnn5uc
 psOE0eTf7wCnSFR++H1r0JpleiQkYbNpfos/jqv5EG5OD6CnvQT4rxny/8fUNg0GW+p6MFo
 D/HLq+BZ1Vi8x8wjPq43GkSN/FJR7lhNnI9Q4eQxCRFJ1HCv1DVgwzkOGOwlwUKvB7UHRP+
 hSkgP+gJMUnqwIy8bp96w==
X-UI-Out-Filterresults: notjunk:1;V01:K0:cP9SCDHyIqc=:EV3doQtbSI8KP2aEIckOAN
 DAoQjdv9y5ZghwlyHYMWNgsuL+7aasXg7Ii72zocO8mjc6ozs5Z5sS6pOeDpon3kJXUFlSceC
 cRqgWiSEgdhvuxZiD9yvD0IIA6cWyzIWre3xrYij+CyefBtlz4lU+9XNKs+vmg/kUppAOYSOO
 9MNipb5/Ftq+dspdkUpMeichWdxz97wclkTVAvZieIHuNuuWqKYME4p+Xg6BcEgb3RkwcM1RI
 CE8f5buh5e4a5BfsN4fSQRF4+TMMlGaFujuExyWW8YVDqEOBauKLyyMrvASXd9M1ZEgEQBWeb
 fYsSGLPjJHhvcxANrC7tuy+RFCcZtlzeZTqO7asKYoL5c9obGTHccZLKnX6YcNtTCHW4/CJw2
 NNxVLEgEqaLFwIWPohVJu59AfL86D1PdUMcI01sqfyJ4wX6upYavEuj7yNukzmbHOnpMnKENg
 6rMT9fQvwDS1huj7iM6z1HFMWeOUs6yQYCaYZNGpxtgfcxYqhIfaUm85ob55aHx8/bU3+3fSS
 HF59H8SfQkSssYTPVdoR4kn6TysV5TOBdVFIP4H7Zo4oaJtVteZ19IhMhYgt7IYAx7ygDdPs5
 L7jR63iYuIKcqkUuxdRZHkhm/XM3lEluph0Dg0ZV800Xag0BxrSrKc46Ck6h40Tn1zsd+xL5j
 0R16RZ0Ose1VT3RNPaCtjybENrqBf63ijyfKi9a9AlCy2BPR3GaZRC3ZtaeqwY3QqNee1zMz2
 xRmfYogvbxWmOje046FsOFaFmtw+/HqPI7z7wPbkFH5pi7enURrk9GeQZ/WBsk4EGXyzau3eW
 sHSRhmSZFKSnrHV/ZPOSKS5M4Osds4m/f8tgGc8sGpZw2L4hz4tkvIpYlOvLp824yxszDJg5V
 bi7XBTn49dykwDik0f6bE44ZhrIolHutwSEXslrfVVC2y1j+gmyOaQnWfBdhX7XaKTFoxKOXO
 ufn8KO7sUNtHkpODjScYYJV7pDRDfkPfnxixG/B4ZQQxd3IUTbDkfTFA0eFqXoLizeCiNpQat
 TL/7Vc3s5kCA808elVNPVK7vQ8Zzi+jijwaT8+0Ot2Xh
X-Spam-Score: -0.2 (/)
X-Debbugs-Envelope-To: 25380
Cc: 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.2 (/)

 >> Apparently, restoring a window configuration doesn't result in the sa=
me
 >> window configuration in batch mode:
 >>
 >> $ emacs -Q -batch -eval '(print (equal (save-window-excursion (curren=
t-window-configuration)) (current-window-configuration)))'
 >>
 >> nil
 >
 > It works in 24.5 and earlier. Something to do with window-edges?
 >
 > emacs -Q -batch --eval '(progn (setq c (current-window-configuration))=

 > (print (window-edges))
 > (set-window-configuration c)
 > (print (window-edges)))'
 >
 > 24.5:
 > (0 1 10 9)
 > (0 1 10 9)
 >
 > 25.1:
 > (0 0 10 9)
 > (0 1 10 10)

IIUC the pixel comes from a menubar line which gets spuriously added.
If someone told me how to debug this, I might be able to tell more.  I
have no idea how the frame seen by =E2=80=98current-window-configuration=E2=
=80=99 gets
created in batch mode.  I never use batch mode.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 8 Jan 2017 23:38:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 08 18:38:51 2017
Received: from localhost ([127.0.0.1]:47245 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQN35-0001ba-CV
	for submit <at> debbugs.gnu.org; Sun, 08 Jan 2017 18:38:51 -0500
Received: from mail-oi0-f43.google.com ([209.85.218.43]:33230)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1cQN33-0001bN-LG
 for 25380 <at> debbugs.gnu.org; Sun, 08 Jan 2017 18:38:50 -0500
Received: by mail-oi0-f43.google.com with SMTP id 128so478969615oig.0
 for <25380 <at> debbugs.gnu.org>; Sun, 08 Jan 2017 15:38:49 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=AjjZeSTCUo9eY8l7M9LIBt4JKkZ81BxyuNIGQtv90ho=;
 b=J8yibxg0kQrhgFkQieXzb7CKUisrAO33d+w9Y8m9TttYXdlzrCvzX+AS3urDhmrOK9
 zW2dCzMIPt0kX64SIWlUIn++Hcwp0BOZ2UB4W/kJ0HcrvhrT0se60Oa0lqaRtZO6lS/l
 pajypOwqGEka6+hHVCikqba88XyRWPr8T8maAFccDigwqzRKqHEAPnUW/qFM9nv1LnEE
 PMZKOxU1nJH7niyUO2Zvf/XaW7cELTmdTLVsh4V/0a4GIQ+N00RL4Ged9JTzxX4aP82S
 LpXd+5J6oili7slgqY45/8yfvJYiPYn8zsrr/p2SNkwK9R0TY5viF+keJf9GZoubjQAS
 B+0Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=AjjZeSTCUo9eY8l7M9LIBt4JKkZ81BxyuNIGQtv90ho=;
 b=KGDOhiaMJkW/osLm2PMhbwp+FqmHAfco06vYJGIToeXYo2m5ONQLjHdS3PpGiD1LWy
 gUp1gxsMZ3DgqgchCo304ktu75vOm24l/MbENPnOXHc6PiLf2yHYrKTqtNkCqZhpmoDX
 jy4SBrthVARed4hVd3bDcymVvQWl51WXatjMkOdy7qjN3dyViVO+HjpJJ+bBw0ESbZiu
 N1rQ84Rb1vy5oO1Az9c6M0xfe/Ub9krnwOIejb5hH2xXQfM9AteOox09pHhKyHDlCevQ
 55HiZ0y8E/oXHdsoDsl+PXYJHm74yCzjCD72edBT+rzWnU7+mAOsFE7mxGFyqpmMZiEg
 I30w==
X-Gm-Message-State: AIkVDXJaNnTjfzXz3uAmIBHaxoJPm254VoO7+AYxtjelChzw1PlHvxr1B7uKqj+CyESYonzmUxLZftfzcvFkCg==
X-Received: by 10.157.3.44 with SMTP id 41mr6352647otv.81.1483918723892; Sun,
 08 Jan 2017 15:38:43 -0800 (PST)
MIME-Version: 1.0
References: <m2vatr3i37.fsf@HIDDEN> <7qwpe5xusr.fsf@HIDDEN>
In-Reply-To: <7qwpe5xusr.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 08 Jan 2017 23:38:33 +0000
Message-ID: <CAArVCkTGDHRKAJN-Qkmt7A2VCuWKutPZUH1oc7hyMPs+opCtCg@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
To: Glenn Morris <rgm@HIDDEN>
Content-Type: multipart/alternative; boundary=94eb2c03096e69c9ec05459dc0b9
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 25380
Cc: martin rudalics <rudalics@HIDDEN>, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.4 (/)

--94eb2c03096e69c9ec05459dc0b9
Content-Type: text/plain; charset=UTF-8

Glenn Morris <rgm@HIDDEN> schrieb am So., 8. Jan. 2017 um 19:37 Uhr:

> Philipp Stephani wrote:
>
> > Apparently, restoring a window configuration doesn't result in the same
> > window configuration in batch mode:
> >
> > $ emacs -Q -batch -eval '(print (equal (save-window-excursion
> (current-window-configuration)) (current-window-configuration)))'
> >
> > nil
>
> It works in 24.5 and earlier. Something to do with window-edges?
>
> emacs -Q -batch --eval '(progn (setq c (current-window-configuration))
> (print (window-edges))
> (set-window-configuration c)
> (print (window-edges)))'
>
> 24.5:
> (0 1 10 9)
> (0 1 10 9)
>
> 25.1:
> (0 0 10 9)
> (0 1 10 10)
>

According to 'git bisect' one of the following commits is the culprit:

768b24eb0e On GNU/Linux, use timerfd for asynchronous timers. * configure.ac
(toplevel): Check whether GNU/Linux-specific timerfd functions and macros
are available. * m4/clock_time.m4 (gl_CLOCK_TIME): Check for clock_getres
as well. * src/atimer.c (toplevel) [HAVE_TIMERFD]: Include sys/timerfd.h.
(toplevel): Rename alarm_timer_ok to special_timer_available.
[HAVE_TIMERFD]: Declare timerfd. [HAVE_CLOCK_GETRES]: Declare resolution.
(start_atimer) [HAVE_CLOCK_GETRES]: Round up timestamp to system timer
resolution. (set_alarm) [HAVE_TIMERFD]: Use timerfd_settime.
(timerfd_callback) [HAVE_TIMERFD]: New function. (atimer_result,
debug_timer_callback, Fdebug_timer_check) [ENABLE_CHECKING]: New function
for the sake of automated tests. (init_atimer) [HAVE_TIMERFD]: Setup
timerfd. [HAVE_CLOCK_GETRES]: Likewise for system timer resolution.
[ENABLE_CHECKING]: Defsubr test function. * src/atimer.h (timerfd_callback)
[HAVE_TIMERFD]: Add prototype. * src/lisp.h (add_timer_wait_descriptor)
[HAVE_TIMERFD]: Likewise. * src/process.c (add_timer_wait_descriptor)
[HAVE_TIMERFD]: New function. * test/automated/timer-tests.el
(timer-tests-debug-timer-check): New test.

7daa4ff121 Parse completion input in a iPython friendly way.

a7947cd874 Fix the GDB xsubchartable command.

34c6b847fb Fix --without-x build and pacify --enable-gcc-warnings. Problems
reported in Bug#18122 and Bug#18124. * frame.c (get_frame_param): Define
even if !HAVE_WINDOW_SYSTEM. (frame_windows_min_size): Now static. *
frame.h (FRAME_HAS_HORIZONTAL_SCROLL_BARS) [!HAVE_WINDOW_SYSTEM]: Define as
no-op. (adjust_frame_size): Always declare prototype.

4256626a7a Prevent Python process shell buffer to pop twice. *
lisp/progmodes/python.el (python-shell-switch-to-shell): Do not call
pop-to-buffer.

414e1537ab Open doc text also if it's not saved to a file.

ca43b53625 * lisp/progmodes/python.el (python-shell-with-shell-buffer): New
macro. (python-shell-font-lock-get-or-create-buffer)
(python-shell-font-lock-kill-buffer)
(python-shell-font-lock-with-font-lock-buffer)
(python-shell-font-lock-cleanup-buffer) (python-shell-font-lock-toggle):
Use it. (python-shell-font-lock-turn-on) (python-shell-font-lock-turn-off):
Use it.  Make command.

da41ffdd08 Merge from emacs-24; up to 2014-06-26T06:55:15Z!rgm@HIDDEN

f5bed1021b Grab all Python process output before inferior-python-mode hooks.

168f8e732d * frame.c (x_set_frame_parameters): Don't use uninitialized
locals.

2daa203c3e Fix Gnus-related issues reported by David Kastrup <dak@HIDDEN>
in <http://lists.gnu.org/archive/html/emacs-devel/2014-07/msg00370.html>. *
atimer.c (timerfd_callback): Always read expiration data. Add comment.
(turn_on_atimers) [HAVE_TIMERFD]: Disarm timerfd timer. * process.c
(add_timer_wait_descriptor): Add timer descriptor to input_wait_mask and
non_process_wait_mask as well.

5dc4b8ca3d Fix some issues with setting the frame height.

72c64ae95a More robust shell startup and code setup.

0f6bbc3da3 Support horizontal scrolling of bidirectional text.

81abec91ee * net/tramp-sh.el (tramp-get-remote-python): Also search for
executables named "python2" or "python3".
(tramp-get-remote-uid-with-python): Use parentheses around arguments to
`print' to make it compatible with Python 3.
(tramp-get-remote-gid-with-python): Ditto.

8862cff49c Fix Changelog typo, introduced by last commit.

96fa02baec Reinstate removed code.

3477e27021 Complete pixelwise frame/window resizing, add horizontal
scrollbar support.

6628be853e * lisp/progmodes/python.el (inferior-python-mode): Make input
prompts read-only.

8e3b4f58f1 In adjust_frame_size use FRAME_WINDOW_P instead of
FRAME_X_WINDOW (Bug#18138).


Unfortunately compilation fails with these commits (on macOS), so I can't
narrow it down any further.

--94eb2c03096e69c9ec05459dc0b9
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">Glenn =
Morris &lt;<a href=3D"mailto:rgm@HIDDEN">rgm@HIDDEN</a>&gt; schrieb am So=
., 8. Jan. 2017 um 19:37=C2=A0Uhr:<br></div><blockquote class=3D"gmail_quot=
e" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex">=
Philipp Stephani wrote:<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
&gt; Apparently, restoring a window configuration doesn&#39;t result in the=
 same<br class=3D"gmail_msg">
&gt; window configuration in batch mode:<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; $ emacs -Q -batch -eval &#39;(print (equal (save-window-excursion (cur=
rent-window-configuration)) (current-window-configuration)))&#39;<br class=
=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; nil<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
It works in 24.5 and earlier. Something to do with window-edges?<br class=
=3D"gmail_msg">
<br class=3D"gmail_msg">
emacs -Q -batch --eval &#39;(progn (setq c (current-window-configuration))<=
br class=3D"gmail_msg">
(print (window-edges))<br class=3D"gmail_msg">
(set-window-configuration c)<br class=3D"gmail_msg">
(print (window-edges)))&#39;<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
24.5:<br class=3D"gmail_msg">
(0 1 10 9)<br class=3D"gmail_msg">
(0 1 10 9)<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
25.1:<br class=3D"gmail_msg">
(0 0 10 9)<br class=3D"gmail_msg">
(0 1 10 10)<br class=3D"gmail_msg"></blockquote><div><br></div><div>Accordi=
ng to &#39;git bisect&#39; one of the following commits is the culprit:</di=
v><div><br></div>





<p class=3D"inbox-inbox-p1">768b24eb0e On GNU/Linux, use timerfd for asynch=
ronous timers. * <a href=3D"http://configure.ac">configure.ac</a> (toplevel=
): Check whether GNU/Linux-specific timerfd functions and macros are availa=
ble. * m4/clock_time.m4 (gl_CLOCK_TIME): Check for clock_getres as well. * =
src/atimer.c (toplevel) [HAVE_TIMERFD]: Include sys/timerfd.h. (toplevel): =
Rename alarm_timer_ok to special_timer_available. [HAVE_TIMERFD]: Declare t=
imerfd. [HAVE_CLOCK_GETRES]: Declare resolution. (start_atimer) [HAVE_CLOCK=
_GETRES]: Round up timestamp to system timer resolution. (set_alarm) [HAVE_=
TIMERFD]: Use timerfd_settime. (timerfd_callback) [HAVE_TIMERFD]: New funct=
ion. (atimer_result, debug_timer_callback, Fdebug_timer_check) [ENABLE_CHEC=
KING]: New function for the sake of automated tests. (init_atimer) [HAVE_TI=
MERFD]: Setup timerfd. [HAVE_CLOCK_GETRES]: Likewise for system timer resol=
ution. [ENABLE_CHECKING]: Defsubr test function. * src/atimer.h (timerfd_ca=
llback) [HAVE_TIMERFD]: Add prototype. * src/lisp.h (add_timer_wait_descrip=
tor) [HAVE_TIMERFD]: Likewise. * src/process.c (add_timer_wait_descriptor) =
[HAVE_TIMERFD]: New function. * test/automated/timer-tests.el (timer-tests-=
debug-timer-check): New test.</p><p class=3D"inbox-inbox-p1">7daa4ff121 Par=
se completion input in a iPython friendly way.</p><p class=3D"inbox-inbox-p=
1">a7947cd874 Fix the GDB xsubchartable command.</p><p class=3D"inbox-inbox=
-p1">34c6b847fb Fix --without-x build and pacify --enable-gcc-warnings. Pro=
blems reported in Bug#18122 and Bug#18124. * frame.c (get_frame_param): Def=
ine even if !HAVE_WINDOW_SYSTEM. (frame_windows_min_size): Now static. * fr=
ame.h (FRAME_HAS_HORIZONTAL_SCROLL_BARS) [!HAVE_WINDOW_SYSTEM]: Define as n=
o-op. (adjust_frame_size): Always declare prototype.</p><p class=3D"inbox-i=
nbox-p1">4256626a7a Prevent Python process shell buffer to pop twice. * lis=
p/progmodes/python.el (python-shell-switch-to-shell): Do not call pop-to-bu=
ffer.</p><p class=3D"inbox-inbox-p1">414e1537ab Open doc text also if it&#3=
9;s not saved to a file.</p><p class=3D"inbox-inbox-p1">ca43b53625 * lisp/p=
rogmodes/python.el (python-shell-with-shell-buffer): New macro. (python-she=
ll-font-lock-get-or-create-buffer) (python-shell-font-lock-kill-buffer) (py=
thon-shell-font-lock-with-font-lock-buffer) (python-shell-font-lock-cleanup=
-buffer) (python-shell-font-lock-toggle): Use it. (python-shell-font-lock-t=
urn-on) (python-shell-font-lock-turn-off): Use it.=C2=A0 Make command.</p><=
p class=3D"inbox-inbox-p1">da41ffdd08 Merge from emacs-24; up to 2014-06-26=
T06:55:15Z!<a href=3D"mailto:rgm@HIDDEN">rgm@HIDDEN</a></p><p class=3D"in=
box-inbox-p1">f5bed1021b Grab all Python process output before inferior-pyt=
hon-mode hooks.</p><p class=3D"inbox-inbox-p1">168f8e732d * frame.c (x_set_=
frame_parameters): Don&#39;t use uninitialized locals.</p><p class=3D"inbox=
-inbox-p1">2daa203c3e Fix Gnus-related issues reported by David Kastrup &lt=
;<a href=3D"mailto:dak@HIDDEN">dak@HIDDEN</a>&gt; in &lt;<a href=3D"http:=
//lists.gnu.org/archive/html/emacs-devel/2014-07/msg00370.html">http://list=
s.gnu.org/archive/html/emacs-devel/2014-07/msg00370.html</a>&gt;. * atimer.=
c (timerfd_callback): Always read expiration data. Add comment. (turn_on_at=
imers) [HAVE_TIMERFD]: Disarm timerfd timer. * process.c (add_timer_wait_de=
scriptor): Add timer descriptor to input_wait_mask and non_process_wait_mas=
k as well.</p><p class=3D"inbox-inbox-p1">5dc4b8ca3d Fix some issues with s=
etting the frame height.</p><p class=3D"inbox-inbox-p1">72c64ae95a More rob=
ust shell startup and code setup.</p><p class=3D"inbox-inbox-p1">0f6bbc3da3=
 Support horizontal scrolling of bidirectional text.</p><p class=3D"inbox-i=
nbox-p1">81abec91ee * net/tramp-sh.el (tramp-get-remote-python): Also searc=
h for executables named &quot;python2&quot; or &quot;python3&quot;. (tramp-=
get-remote-uid-with-python): Use parentheses around arguments to `print&#39=
; to make it compatible with Python 3. (tramp-get-remote-gid-with-python): =
Ditto.</p><p class=3D"inbox-inbox-p1">8862cff49c Fix Changelog typo, introd=
uced by last commit.</p><p class=3D"inbox-inbox-p1">96fa02baec Reinstate re=
moved code.</p><p class=3D"inbox-inbox-p1">3477e27021 Complete pixelwise fr=
ame/window resizing, add horizontal scrollbar support.</p><p class=3D"inbox=
-inbox-p1">6628be853e * lisp/progmodes/python.el (inferior-python-mode): Ma=
ke input prompts read-only.</p><p class=3D"inbox-inbox-p1">8e3b4f58f1 In ad=
just_frame_size use FRAME_WINDOW_P instead of FRAME_X_WINDOW (Bug#18138).</=
p><div><br></div><div><br></div><div>Unfortunately compilation fails with t=
hese commits (on macOS), so I can&#39;t narrow it down any further.</div></=
div></div>

--94eb2c03096e69c9ec05459dc0b9--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at 25380 <at> debbugs.gnu.org:


Received: (at 25380) by debbugs.gnu.org; 8 Jan 2017 18:37:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 08 13:37:21 2017
Received: from localhost ([127.0.0.1]:47089 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cQILJ-0004Gj-C5
	for submit <at> debbugs.gnu.org; Sun, 08 Jan 2017 13:37:21 -0500
Received: from eggs.gnu.org ([208.118.235.92]:52844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1cQILI-0004GV-JE
 for 25380 <at> debbugs.gnu.org; Sun, 08 Jan 2017 13:37:20 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <rgm@HIDDEN>) id 1cQILC-0006TM-Cj
 for 25380 <at> debbugs.gnu.org; Sun, 08 Jan 2017 13:37:15 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-3.2 required=5.0 tests=BAYES_40,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:59933)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rgm@HIDDEN>)
 id 1cQIL8-0006Sh-Vc; Sun, 08 Jan 2017 13:37:10 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rgm@HIDDEN>)
 id 1cQIL7-0007lF-4T; Sun, 08 Jan 2017 13:37:09 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#25380: 25.1; save-window-excursion problem in batch mode
References: <m2vatr3i37.fsf@HIDDEN>
X-Spook: Drug war Antiviral BLU-97 A/B BLU-114/B Disaster medical
X-Ran: {Ko4g"aoph8|!3=4d<U;E+hw726kRt:}{x^Qa8#Z&n=-s_y\cvx),E;|A&7GtZb3yTQF6w
X-Hue: brightwhite
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Sun, 08 Jan 2017 13:37:08 -0500
In-Reply-To: <m2vatr3i37.fsf@HIDDEN> (Philipp Stephani's message of "Sat,
 07 Jan 2017 00:05:16 +0100")
Message-ID: <7qwpe5xusr.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -8.2 (--------)
X-Debbugs-Envelope-To: 25380
Cc: martin rudalics <rudalics@HIDDEN>, 25380 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -8.2 (--------)

Philipp Stephani wrote:

> Apparently, restoring a window configuration doesn't result in the same
> window configuration in batch mode:
>
> $ emacs -Q -batch -eval '(print (equal (save-window-excursion (current-window-configuration)) (current-window-configuration)))'
>
> nil

It works in 24.5 and earlier. Something to do with window-edges?

emacs -Q -batch --eval '(progn (setq c (current-window-configuration))
(print (window-edges))
(set-window-configuration c)
(print (window-edges)))'

24.5:
(0 1 10 9)
(0 1 10 9)

25.1:
(0 0 10 9)
(0 1 10 10)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Jan 2017 23:05:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 06 18:05:38 2017
Received: from localhost ([127.0.0.1]:45449 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cPdZq-00006G-3s
	for submit <at> debbugs.gnu.org; Fri, 06 Jan 2017 18:05:38 -0500
Received: from eggs.gnu.org ([208.118.235.92]:34555)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1cPdZo-000063-9T
 for submit <at> debbugs.gnu.org; Fri, 06 Jan 2017 18:05:36 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1cPdZh-0007pA-MY
 for submit <at> debbugs.gnu.org; Fri, 06 Jan 2017 18:05:30 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.1 required=5.0 tests=BAYES_50,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:53035)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <p.stephani2@HIDDEN>)
 id 1cPdZh-0007p6-JJ
 for submit <at> debbugs.gnu.org; Fri, 06 Jan 2017 18:05:29 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:53752)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1cPdZg-0007LP-7m
 for bug-gnu-emacs@HIDDEN; Fri, 06 Jan 2017 18:05:29 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1cPdZf-0007mz-5S
 for bug-gnu-emacs@HIDDEN; Fri, 06 Jan 2017 18:05:28 -0500
Received: from mail-wj0-x230.google.com ([2a00:1450:400c:c01::230]:34410)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <p.stephani2@HIDDEN>)
 id 1cPdZe-0007md-St
 for bug-gnu-emacs@HIDDEN; Fri, 06 Jan 2017 18:05:27 -0500
Received: by mail-wj0-x230.google.com with SMTP id tn15so43723158wjb.1
 for <bug-gnu-emacs@HIDDEN>; Fri, 06 Jan 2017 15:05:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=c4aDetXjp6rS/FeeTcEXSJvQnARv01a5OMvdg67aFIY=;
 b=YthRVkl7vHSn1qAUtl4FOUuhcWEann+U/Z4ypN8kPZgYxRstQBQpO1Y2NWhkW9unnO
 gLh6EPBUoSXUIbv4StSAKm5yKWASUT44o+Gk0wRtOrwUZXE0KFMayz1Rpbe4e7UjZX5J
 3uYn9u7vqggjttgUFOrMe5+RI9d5TWow2cN4c/vQ8VBNyq/t/it8JChsOsH+IJmF5jiK
 z9x6oDCxkg1Dn+IjfsVVFGymlvzEHYee2nVVNc93/GPFe+jn9Ng4sP2eVEM6T02EMyEU
 Px4rnLj2MAKc1fGEc5SpB0OCb/ixxQ8dZ8MdZnp92+AVlSaASlNtxrC+pDdf3fWCwFOJ
 p4Qw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=c4aDetXjp6rS/FeeTcEXSJvQnARv01a5OMvdg67aFIY=;
 b=iY/mLa1Jd98Jyk5ZvRn1oFty8UWFxCFUBcAIoQy/QR/aamBMOcs52gg0g+ZoHEjfGy
 gOusnSqwXRQlQKnEoFeQZFKgVt9w54D+ymqqyDK8TaH/5eQf69xkfEOCqb10romUPLDR
 phLBUdvTIiUhrlHiLWJJMi+Son2VL+uDnVmWZB1HxTMRC2BXYLCFIDg9mrivxjdDJu71
 fG46th1xGj/WY0K0g73HraBczUA4ctwYqI6Xr58B//NYnmG7jtCu1x2Ju4/goG4H0zOG
 BjLTFbVAEIYU67LOgTw26p9fyYM/7YpUnvq3nUcuxsrKL0bPQe8b7HbKH+mtrYbOfZR5
 xluA==
X-Gm-Message-State: AIkVDXLHhuMLGzptQWL54xC+CMgvRqcThxGokm4JBR0Nvrskh2kF7TS6lz9cTFfpraXzNg==
X-Received: by 10.194.157.3 with SMTP id wi3mr61338252wjb.0.1483743925354;
 Fri, 06 Jan 2017 15:05:25 -0800 (PST)
Received: from p ([2001:4c50:258:d700:bdf6:6d99:3428:517f])
 by smtp.gmail.com with ESMTPSA id a13sm5550175wma.18.2017.01.06.15.05.24
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 06 Jan 2017 15:05:24 -0800 (PST)
From: Philipp Stephani <p.stephani2@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 25.1; save-window-excursion problem in batch mode
Date: Sat, 07 Jan 2017 00:05:16 +0100
Message-ID: <m2vatr3i37.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)


Apparently, restoring a window configuration doesn't result in the same
window configuration in batch mode:

$ emacs -Q -batch -eval '(print (equal (save-window-excursion (current-window-configuration)) (current-window-configuration)))'

nil

This is unexpected, especially in unit tests that want to check window
comparisons.  In interactive mode, this works (i.e. (equal
(save-window-excursion (current-window-configuration))
(current-window-configuration)) is t).




In GNU Emacs 25.1.1 (x86_64-apple-darwin15.6.0, NS appkit-1404.47 Version 10.11.6 (Build 15G1004))
 of 2016-09-22 built on p
Windowing system distributor 'Apple', version 10.3.1504
Configured using:
 'configure --disable-dependency-tracking --disable-silent-rules
 --enable-locallisppath=/usr/local/share/emacs/site-lisp
 --infodir=/usr/local/Cellar/emacs/25.1/share/info/emacs
 --prefix=/usr/local/Cellar/emacs/25.1 --without-x --with-xml2
 --without-dbus --without-gnutls --with-rsvg --with-ns
 --disable-ns-self-contained'

Configured features:
JPEG RSVG NOTIFY ACL LIBXML2 ZLIB TOOLKIT_SCROLL_BARS NS

Important settings:
  value of $LANG: de_DE.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message dired format-spec rfc822 mml
mml-sec password-cache epg epg-config gnus-util mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail
rfc2047 rfc2045 ietf-drums mm-util help-fns help-mode easymenu
cl-loaddefs pcase cl-lib mail-prsvr mail-utils time-date mule-util
tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
mwheel ns-win ucs-normalize term/common-win tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment elisp-mode lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core frame cl-generic cham
georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese charscript case-table epa-hook
jka-cmpr-hook help simple abbrev minibuffer cl-preloaded nadvice
loaddefs button faces cus-face macroexp files text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote kqueue cocoa ns multi-tty
make-network-process emacs)

Memory information:
((conses 16 196126 8185)
 (symbols 48 19634 0)
 (miscs 40 50 169)
 (strings 32 15015 5817)
 (string-bytes 1 435313)
 (vectors 16 32909)
 (vector-slots 8 654000 5657)
 (floats 8 158 18)
 (intervals 56 210 0)
 (buffers 976 18))




Acknowledgement sent to Philipp Stephani <p.stephani2@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#25380; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 10 Jan 2017 18:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.